#include "gio/gio.h"
#include <adwaita.h>
#include <gtk/gtk.h>

static void on_activate(GtkApplication *app, gpointer user_data) {
  // Create the main window
  AdwMessageDialog *dialog = ADW_MESSAGE_DIALOG(
      adw_message_dialog_new(NULL, "Allow access?", "allow_access?"));

  // Set the dialog as transient for the (non-existent) parent window
  gtk_window_set_application(GTK_WINDOW(dialog), app);

  // Add response buttons
  adw_message_dialog_add_response(dialog, "cancel", "Cancel");
  adw_message_dialog_add_response(dialog, "ok", "OK");

  // Set default response
  adw_message_dialog_set_default_response(dialog, "ok");

  // Set close response (when clicking X)
  adw_message_dialog_set_close_response(dialog, "cancel");

  // Connect response handler
  // g_signal_connect(dialog, "response", G_CALLBACK(gtk_window_close), dialog);

  // Show the dialog
  gtk_window_present(GTK_WINDOW(dialog));
}

int main(int argc, char **argv) {
  // Create a new application
  AdwApplication *app = adw_application_new("com.example.zenityclone",
                                            G_APPLICATION_DEFAULT_FLAGS);
  g_signal_connect(app, "activate", G_CALLBACK(on_activate), NULL);

  // Run the application
  int status = g_application_run(G_APPLICATION(app), argc, argv);
  g_object_unref(app);

  return status;
}
